


--                            $ol.VHD
--                           㬬
--
--
type    tl              is (5,6); 
type    ta              is array (1 to 11)              of bit;
type    td              is array (1 to 7)              of bit;
type    tn              is array (8 to 11 )              of bit;

entity $ol
is
generic (M1 :bit;
         M2 :bit;
         M3 :bit;
         M4 :bit   
        );
port    (
       run : in  bit;
       DATA: out td
         );
end $ol;

architecture ol of $ol is
begin
OL:
block
        signal  a,b,d,cl,io,mr,rw,mn,mj,ir,x : bit;
        signal  c,g,v                     : tn;
        signal nbus,mdbus,fc,fv               : td;
        signal af                       :ta;  
 
  component     CPU
                port    (
                        dd : out tn;
                        clock: in bit;
                        ioreq: out bit;
                        mreq :out bit;
                        rw:out bit;
                        m    :out tn  
                        );
  end component;

 component     CLK
                port    (
                        ran: in bit;
                        cl : out bit
                         );
  end component;

  component     DEK
                port    (
                          ra  : in tn;
                          m1 : out bit;
                          m2 : out bit;
                          m3 : out bit;
                          m4 : out bit
                        );
  end component;


  component     ROM
                port    (
                        m1 : in bit;
                        mreq   : in bit;
                        addr : in tn;
                        dbus : out td
                        );
  end component;

  component     RAM1	
                port    (
                        m2 : in bit;
                        mreq : in bit;
                        rwb :in bit;
                        addr:in tn;
                        dbus:out td
                        );
  end component;

  component     RAM2	
                port    (
                        m3 : in bit;
                        mreq : in bit;
                        rwb :in bit;
                        addr:in tn;
                        dbus:out td
                        );
  end component;

  component     RAM3	
                port    (
                        m4 : in bit;
                        mreq : in bit;
                        rwb :in bit;
                        addr:in tn;
                        dbus:out td
                        );
  end component;

 
  component     LAT
                port    (
                        ena : in bit;
                        dbus  : in td;
                        DATA  : out td
                         );
  end component;



  begin
--    if(M1='1') generate
       d1: cpu      port    map (g,io,mj,mn,ir,c);      
       d2: lat      port    map (mj,fc,data);
       d3: dek      port    map (g,a,b,d,x);
       d4: clk      port    map (run,io);
--    if (M1='1') generate 
       d5: rom      port    map (a,ir,c,fc);
       d6: ram1     port    map (b,ir,mn,c,fc);
       d7: ram2     port    map (d,ir,mn,c,fc);
       d8: ram3     port    map (x,ir,mn,c,fc);
end block;      
end ol;