entity Var15 is
 	port (C,X11,X12,X13,X14,X21,X22,X23,X24,A1,A2: in bit; Y1,NY1,Y2,NY2: out bit);
end Var15;

architecture BEHAVIOR of Var15 is
   begin
      process
         begin             
         if (C='0') then 
               case (A1 & A2) is
         	when "00" => Y1<=X11; NY1<=not(X11); Y2<=X21; NY2<=not(X21);
		when "01" => Y1<=X12; NY1<=not(X12); Y2<=X22; NY2<=not(X22);
		when "10" => Y1<=X13; NY1<=not(X13); Y2<=X23; NY2<=not(X23);
		when "11" => Y1<=X14; NY1<=not(X14); Y2<=X24; NY2<=not(X24);
	       end case;
         else Y1<='0'; NY1<='1'; Y2<='0'; NY2<='1'; 
         end if;
         wait  on  C,X11,X12,X13,X14,X21,X22,X23,X24,A1,A2;
      end process;
   end ;

library vector;
use std.textio.all,vector.functions.all;
entity test is
end test;

architecture behaviour of test is
  component Var15
 	port (C,X11,X12,X13,X14,X21,X22,X23,X24,A1,A2: in bit; Y1,NY1,Y2,NY2: out bit);
  end component;
    signal op2: bit_vector (0 to 3);
    signal op3: bit_vector (0 to 3);
    signal op4: bit_vector (0 to 1);
    signal op1,result1,result2,result3,result4 : bit_vector(0 to 0);

begin
  inst1: var15 port map (op1(0),op2(0),op2(1),op2(2),op2(3),op3(0),op3(1),op3(2),op3(3),op4(0),op4(1),result1(0),result2(0),result3(0),result4(0));
  p1: process
    variable l : line;
    variable a,b,c,d : integer;
  begin
    write(l,"Enter four operands separated by a space.");
    writeline(output,l);
    readline(input,l);
    read(l,a);
    read(l,b);
    read(l,c);
    read(l,d);
    op1<=to_bit(1,a);
    op2<=to_bit(4,b);
    op3<=to_bit(4,c);
    op4<=to_bit(2,d);
    wait for 3ns;
  end process;
end;
